#ifndef __DUT_INCLUDED__
#define __DUT_INCLUDED__

#include <SpvHfile.h>
#include <deque>

//Submodule definition
class	Dut : public SpvModule
{
	SpvWireConnection	m_Clk;
    SpvWireConnection	m_ResetN;
	SpvWireConnection	m_DataIn;
	SpvWireConnection	m_DataInValid;
    SpvSig              m_DataOut;
    SpvSig              m_DataOutValid;

    deque<unsigned>     m_DataFifo;
    deque<unsigned>     m_DataEnFifo;

    unsigned            m_FifoDepth;
	
public:
    Dut(SpvModule *owner,string name);

	void OnInitSim();

    void OnInitial();

    //Connect outer module's signal to inputs and outputs
    void InitConnection(SpvSig& clk, 
                         SpvSig& resetN, 
                         SpvSig& dataIn, 
                         SpvSig& dataInValid, 
                         SpvWireConnection& dataOut, 
                         SpvWireConnection& dataOutValid);


    //Atomic process on positive edge of clock
	void PosClkFunc(); 

    //Atomic process on negative edge of reset
    void NegResetFunc();
};

#endif

