#include "Tb.h"


Tb::Tb(SpvModule* owner,string name):
	SpvModule(owner,name),              //Set name and link to parent module
                                        //Name sigs and wires
	m_Clk(FullPath() + ".clock"),           
	m_ResetN(FullPath() + ".reset_n"),           
	m_DataIn(FullPath() + ".data_in"),       
	m_DataInValid(FullPath() + ".data_in_valid"),  
	m_DataOut(FullPath() + ".data_out"),     
	m_DataOutValid(FullPath() + ".data_out_valid"),   
	SpvSimDeltaT(50)                    //Setup call to SpvOnDelta() every 50 units
{
	m_Dut = NULL;
}

void Tb::SpvOnDelta() 
{ 
    m_Clk = ~m_Clk; 
}

void Tb::OnInitSim()
{
    //Set size of signals
	SpvNullSim::SetSigSize(m_Clk, 1);
	SpvNullSim::SetSigSize(m_ResetN, 1);
	SpvNullSim::SetSigSize(m_DataIn, 4);
	SpvNullSim::SetSigSize(m_DataInValid, 1);
	SpvNullSim::SetSigSize(m_DataOut, 4);
	SpvNullSim::SetSigSize(m_DataOutValid, 1);

    //Instantiate submodules
    m_Dut = new Dut(this,"BookTest");

    //Connect submodule to clock sig
	m_Dut->InitConnection(m_Clk, m_ResetN, m_DataIn, m_DataInValid, 
        m_DataOut, m_DataOutValid);
}

void Tb::OnInitial() 
{ 
    m_Clk = 0; 
}


